
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.


--example in the construction of petri nets using the vhdl design
--entities and package of in this directory.  this example
--instantiates a simple control unit of a microprocessor.

library petri;
use petri.petri.all;
entity control_unit is

end;


architecture demo of control_unit is

signal arc1, arc2, arc3, arc4, arc5, 
       arc6, arc7, arc8, arc9, arc10,
       arc11, arc12 : arc bus; 

component place_1_0

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug);

    port (in_arc1 : inout arc bus );

end component;

component place_0_1

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (out_arc1 : inout arc bus );

end component;

component place_1_1

    generic (initial_marking : integer;
             place_name      : string;
             debug_cntrl     : debug := trace_tokens);

    port (in_arc1, out_arc1  : inout arc bus);
    
end component;

component transition_1_4

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1            : inout arc bus;
          out_arc1, out_arc2,
          out_arc3, out_arc4 : inout arc bus);

end component;

component transition_5_2

    generic (transition_name : string;
             debug_cntrl     : debug := firing);

    port (in_arc1,  in_arc2,
          in_arc3, in_arc4,
          in_arc5            : inout arc bus;
          out_arc1, out_arc2 : inout arc bus);

end component;

for P1, P2, P3 : place_1_1 use entity work.place_1_1(structure);
for P4, P6     : place_1_1 use entity work.place_1_1(structure);  
for P5         : place_0_1 use entity work.place_0_1(structure);
for P7         : place_1_0 use entity work.place_1_0(structure);

for T1     : transition_1_4 use entity work.transition_1_4(structure);
for T2     : transition_5_2 use entity work.transition_5_2(structure);

begin

P1 : place_1_1 
     generic map (1, "Reg_k")
     port map (arc1, arc2);
P2 : place_1_1
     generic map (1, "Reg_j")
     port map (arc3, arc4);
P3 : place_1_1 
     generic map (1, "Reg_i")
     port map (arc5, arc6);
P4 : place_1_1
     generic map (1, "Free_u")
     port map (arc7, arc8);
P5 : place_0_1 
     generic map (1, "Instr")
     port map (arc9);
P6 : place_1_1
     generic map (0, "Unit_u")
     port map (arc11, arc12);
P7 : place_1_0
     generic map (0, "Ready", trace_tokens)
     port map (arc10);
T1 : transition_1_4
     generic map ("Instr_comp")
     port map (arc12, arc1, arc3, arc5, arc7);
T2 : transition_5_2
     generic map ("Issue_instr")
     port map (arc2, arc4, arc6, arc8, arc9, arc10, arc11);

end;
